# coding: utf-8

"""
    Tator REST API

    Interface to the Tator backend.  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ..configuration import Configuration


class GroupSpec(object):
    """
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'initial_members': 'list[int]',
        'name': 'str'
    }

    attribute_map = {
        'initial_members': 'initial_members',
        'name': 'name'
    }

    def __init__(self, initial_members=None, name=None, local_vars_configuration=None):  # noqa: E501
        """GroupSpec - a model defined in OpenAPI"""
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._initial_members = None
        self._name = None
        self.discriminator = None

        if initial_members is not None:
            self.initial_members = initial_members
        self.name = name

    @property
    def initial_members(self):
        """
        List of members to add to the group upon creation (user pk)

        :return: The initial_members of this GroupSpec. 
        :rtype: list[int]
        """
        return self._initial_members

    @initial_members.setter
    def initial_members(self, initial_members):
        """
        List of members to add to the group upon creation (user pk)

        :param initial_members: The initial_members of this GroupSpec.
        :type: list[int]
        """

        self._initial_members = initial_members

    @property
    def name(self):
        """
        Group Name

        :return: The name of this GroupSpec. 
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Group Name

        :param name: The name of this GroupSpec.
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GroupSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GroupSpec):
            return True

        return self.to_dict() != other.to_dict()
